%MATLAB: p43.m
g=9.8; ell1=0.5; ell2=1; m1=0.5; m2=1; h1=1; h2=1;
J1=4/3*m1*ell1^2; J2=4/3*m2*ell2^2;
a1=3*g/4/ell1; a2=3*g/4/ell2; b1=h1/J1; b2=h2/J2;
A=[ 0  0 1 0;
    0  0 0 1;
   a1  0 0 0;
    0 a2 0 0];
B=[0;0;b1;b2];
n=size(A,1);
lambda=eig(A)
for i=1:n
  if real(lambda(i))>=0, rank([B A-lambda(i)*eye(n,n)]), end
end
%---
p=[-5 -5 -7 -7];
F=sf(A,B,p)
lambda=eig(A-B*F)
%---
t=0:0.05:5; x0=[3/180*pi; 1/180*pi; 0; 0];
[t,x]=ode45(@(t,x) (A-B*F)*x,t,x0);
C=180/pi*eye(2,4);
figure(1)
subplot(211), plot(t,x*C'),  grid, xlabel('t'), ylabel('th1(t),th2(t)')
subplot(212), plot(t,-x*F'), grid, xlabel('t'), ylabel('u(t)')
%---
function F=sf(A,B,p)
  n=size(A,1);
  X=B; for i=2:n, X=[B A*X]; end
  F0=[zeros(1,n-1) 1]/X;
  b=[1 -p(1)]; for i=2:n, b=conv(b,[1 -p(i)]); end
  F=F0; for i=1:n, F=F*A+F0*b(i+1); end
end