%MATLAB: p51.m
Tm=0.01; KE=0.05;
x0=[1;10];
t=0:0.001:0.05;
[t1,x1]=ode45(@(t,x) [0 1; 0 -1/Tm]*x+[0;1/Tm/KE],t,x0);
%-----Part 1
alpha=1.2
h1=-(1-2*alpha)/Tm; h2=(1-alpha)^2/Tm^2;
[t2,x2]=ode45(@(t,x) [-h1 1; -h2 -1/Tm]*x,t,-x0);
%-----Part 2
alpha=1.8
h1=-(1-2*alpha)/Tm; h2=(1-alpha)^2/Tm^2;
[t3,x3]=ode45(@(t,x) [-h1 1; -h2 -1/Tm]*x,t,-x0);
%-----
subplot(121), plot(t,180/pi*x1(:,1)), hold on
subplot(121), plot(t,180/pi*(x1(:,1)+x2(:,1)),'-.')
subplot(121), plot(t,180/pi*(x1(:,1)+x3(:,1)),'--')
grid, axis([0 0.05 0 120])
xlabel('t'), ylabel('theta(t)')
legend('theta','alpha=1.2','alpha=1.8');
subplot(122), plot(t,x1(:,2)), hold on
subplot(122), plot(t,x1(:,2)+x2(:,2),'-.')
subplot(122), plot(t,x1(:,2)+x3(:,2),'--')
grid, axis([0 0.05 0 30])
legend('omega','alpha=1.2','alpha=1.8');
xlabel('t'), ylabel('omega(t)')