%MATLAB: p73.m
m=1; A=[0,1;0,0]; B=[0;1/m]; C=eye(2,2);
q1=1; q2=1; Q=diag([q1,q2].^2); R=1;
[F,p]=opt(A,B,C,Q,R)
%---
r0=-1;v0=0;rc=0;vc=0;e0=[rc-r0;vc-v0];
t0=0;t=0:0.1:10;
[t,e]=ode45(@(t,e) (A-B*F)*e,t,e0);
r=rc-e(:,1);v=vc-e(:,2);
subplot(211),plot(t,r),grid,title('r(t)')
subplot(212),plot(t,v),grid,title('v(t)')
%---
function [F,p]=opt(A,B,C,Q,R)
  n=size(A,1);
  w2=R\B';
  [v,p]=eig([A -B*w2;-C'*Q*C -A']);
  p=diag(p);
  [dummy,index]=sort(real(p));
  p=p(index(1:n));
  x=v(1:n,index(1:n));
  y=v(n+1:n+n,index(1:n));
  X=real(y/x);
  F=w2*X;
end
