%MATLAB: p83.m
m=1; a=0; b=1/m; c=1;
AE=[a b;0 0]; BE=[0;1];
QE=diag([1,2].^2); RE=1; 
F=opt(AE,BE,eye(2,2),QE,RE);
K=F/[a b;c 0]; kv=K(1); kI=K(2);
%---
AF=[-kv/m -kI/m;1 0]; 
ws=1; w=[1/m*ws;0];
v0=1; vc=0.5; x0=[vc-v0;0];
t0=0; t=0:0.1:20;
[t,x]=ode45(@(t,x) AF*x+w,t,x0);
v=vc-x(:,1); d=-kI*x(:,2); 
subplot(211), plot(t,v), grid, title('v(t)')
subplot(212), plot(t,d), grid, title('xI(t)')
%---
function [F,p]=opt(A,B,C,Q,R)
  n=size(A,1);
  w2=R\B';
  [v,p]=eig([A -B*w2;-C'*Q*C -A']);
  p=diag(p);
  [dummy,index]=sort(real(p));
  p=p(index(1:n));
  x=v(1:n,index(1:n));
  y=v(n+1:n+n,index(1:n));
  X=real(y/x);
  F=w2*X;
end
