%MATLAB: p84.m
m=1; A=[0 1; 0 0]; B=[0;1/m]; C=[1 0]; S=[A B;C 0];
AE=[A B;0 0 0]; BE=[0;0;1];
QE=diag([1,2,1].^2); RE=2^2; 
F=opt(AE,BE,eye(3,3),QE,RE);
K=F/S; 
kr=K(1); kv=K(2); kI=K(3);
%---
AF=[0 1 0;-kr/m -kv/m -kI/m;1 0 0];
ws=1; w=[0;1/m*ws;0];
r0=-1; rc=0; v0=0; vc=0; x0=[rc-r0;vc-v0;0];
t0=0; t=0:0.1:20;
[t,x]=ode45(@(t,x) AF*x+w,t,x0);
r=rc-x(:,1); d=-kI*x(:,3);
subplot(211), plot(t,r), grid, title('r(t)')
subplot(212), plot(t,d), grid, title('xI(t)')
%---
function [F,p]=opt(A,B,C,Q,R)
  n=size(A,1);
  w2=R\B';
  [v,p]=eig([A -B*w2;-C'*Q*C -A']);
  p=diag(p);
  [dummy,index]=sort(real(p));
  p=p(index(1:n));
  x=v(1:n,index(1:n));
  y=v(n+1:n+n,index(1:n));
  X=real(y/x);
  F=w2*X;
end
